/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 * Click nbfs://nbhost/SystemFileSystem/Templates/Classes/Class.java to edit this template
 */
package my.numberaddition;

import java.util.*;
        
/**
 *
 * @author a.sveshnikov
 */
 
public class frameExecutor {
          
    final byte ENABLE_DEVICE_TYPE_OPCODE = (byte)0xC1;
    final byte SET_DTR1_OPCODE =  (byte)0xC3;
    
    public final byte SPEC_LED_LAMP = 6;
    public final byte SPEC_INCANDESCENT_LAMP = 4;
    public final byte SPEC_COLOUR_CONTROL = 8;
    public final byte SPEC_SELF_CONTAINED_EMERGENCY_LIGHTNING = 2;
    
    final byte OFF_OPCODE = 0;
    final byte RESET_OPCODE = 32;
    final byte SAVE_PERSISTENT_VARIABLES = (byte)0x22;   
     
    public static final byte BROADCAST_ADDR = 0;
    public static final byte BROADCAST_UNADDRESSED = 1;
    public static final byte GROUP_ADDR = 2;
    public static final byte INDIVIDUAL_ADDR = 3;
    
    final byte MASTER_VID_PID = 0;
    
    final byte  SET_FADE_TIME_OPCODE = (byte)0x2E;
    final byte  SET_FADE_RATE_OPCODE = (byte)0x2F;
    final byte  SET_EXTENDED_FADE_TIME_OPCODE = (byte)0x30;
    final byte  QUERY_VERSION_NUMBER = (byte)0x97;
    final byte  QUERY_DEVICE_TYPE = (byte)0x99;
    final byte  ENABLE_WRITE_MEMORY = (byte)129;
    final byte  QUERY_STATUS  = (byte)144;
    final byte  QUERY_CONTENT_DTR0 = (byte)152;
    final byte  QUERY_ACTUAL_LEVEL = (byte)160;
    final byte  QUERY_POWER_ON_LEVEL = (byte)163;
    final byte  QUERY_SYSTEM_FAILURE_LEVEL = (byte)164;
    final byte  QUERY_FADE_TIME_RATE = (byte)165;
    final byte  QUERY_SCENE_LEVEL_0 = (byte)176;
    final byte  QUERY_SCENE_LEVEL_15 = (byte)19;
    final byte  QUERY_RANDOM_ADDR_H = (byte)194;
    final byte  QUERY_RANDOM_ADDR_M = (byte)195;
    final byte  QUERY_RANDOM_ADDR_L = (byte)196;
    final byte  READ_MEMORY_LOCATION = (byte)197;

    final byte  MASTER_CMD           = (byte)0x00;
    final byte  SLAVE_CMD            = (byte)0x01;
    final byte  SLAVE_EMPTY_CMD      = (byte)0x02;
    final byte  SLAVE_REPLY_TOUT_CMD = (byte)0x03;
    final byte  SLAVE_CMDS_SEQ       = (byte)0x04;

    final byte  COMMAND_SEND_TWICE_FLAG    = (byte)0x80;
    final byte  COMMAND_EXPECT_ANSWER_FLAG = (byte)0x40;
    final byte  COMMAND_SPECIAL_FLAG       = (byte)0x20;

    byte[] frame;
    int cmdId;
    byte address_byte;
    byte opcode_byte;
    
    byte replyByte = 0;
    
    int vid;
    int pid;
    
    ArrayList<cmdsConvTab> standartCmdsConvTab = new ArrayList<>(); 
    ArrayList<cmdsConvTab> extendedCmdsSpec207ConvTab = new ArrayList<>();
    ArrayList<cmdsConvTab> extendedCmdsSpec205ConvTab = new ArrayList<>();
    ArrayList<cmdsConvTab> extendedCmdsSpec209ConvTab = new ArrayList<>();
     
    class cmdsConvTab
    {
       cmdsConvTab( int cmd_num, boolean dtr_0, boolean dtr_1, boolean dtr_2, boolean _answer, boolean send_twice ) 
       {
           this.cmdNum = (byte)cmd_num;
           this.dtr0 = dtr_0;
           this.dtr1 = dtr_1;
           this.dtr2 = dtr_2;
           this.answer = _answer;
           this.sendTwice = send_twice;
       }        
       byte cmdNum;
       boolean dtr0;
       boolean dtr1;
       boolean dtr2;
       boolean answer;
       boolean sendTwice;
    }
    
    ArrayList<specCmdsConvTab>  specCmdsConvTab = new ArrayList<>(); // = new ArrayList<cmdsConvTab>();
    
    class specCmdsConvTab
    {
       specCmdsConvTab(byte addr_byte, int cmd_num, boolean opcode_not_null, boolean send_twice, boolean _answer) 
       {
           this.addressByte = addr_byte;
           this.cmdNum = cmd_num;
           this.opcodeNotNull = opcode_not_null;
           this.sendTwice = send_twice;
           this.answer = _answer;
       }        
       byte addressByte;
       int cmdNum;
       boolean opcodeNotNull;
       boolean sendTwice;
       boolean answer;
    }
    
    public frameExecutor() {
        standartCmdsConvTab.add(new cmdsConvTab(OFF_OPCODE, false, false, false, false, false));    //OFF
        standartCmdsConvTab.add(new cmdsConvTab(1, false, false, false, false, false));    //UP
        standartCmdsConvTab.add(new cmdsConvTab(2, false, false, false, false, false));    //DOWN
        standartCmdsConvTab.add(new cmdsConvTab(3, false, false, false, false, false));   //STEP UP
        standartCmdsConvTab.add(new cmdsConvTab(4, false, false, false, false, false));    //STEP DOWN
        standartCmdsConvTab.add(new cmdsConvTab(5, false, false, false, false, false));    //RECALL MAX LEVEL
        standartCmdsConvTab.add(new cmdsConvTab(6, false, false, false, false, false));    //RECALL MIN LEVEL
        standartCmdsConvTab.add(new cmdsConvTab(7, false, false, false, false, false));    //STEP DOWN AND OFF
        standartCmdsConvTab.add(new cmdsConvTab(8, false, false, false, false, false));    //ON AND STEP UP
        standartCmdsConvTab.add(new cmdsConvTab(9, false, false, false, false, false));    //ENABLE DAPC SEQUENCE
        standartCmdsConvTab.add(new cmdsConvTab(10, false, false, false, false, false));    //GO TO LAST ACTIVE LEVEL
        standartCmdsConvTab.add(new cmdsConvTab(16, false, false, false, false, false));    //GO TO SCENE 0
        standartCmdsConvTab.add(new cmdsConvTab(17, false, false, false, false, false));   //
        standartCmdsConvTab.add(new cmdsConvTab(18, false, false, false, false, false));    //
        standartCmdsConvTab.add(new cmdsConvTab(19, false, false, false, false, false));   //GO TO SCENE 3
        standartCmdsConvTab.add(new cmdsConvTab(20, false, false, false, false, false));    //
        standartCmdsConvTab.add(new cmdsConvTab(21, false, false, false, false, false));    //
        standartCmdsConvTab.add(new cmdsConvTab(22, false, false, false, false, false));   //GO TO SCENE 6
        standartCmdsConvTab.add(new cmdsConvTab(23, false, false, false, false, false));    //
        standartCmdsConvTab.add(new cmdsConvTab(24, false, false, false, false, false));    //
        standartCmdsConvTab.add(new cmdsConvTab(25, false, false, false, false, false));    //GO TO SCENE 9
        standartCmdsConvTab.add(new cmdsConvTab(26, false, false, false, false, false));    //
        standartCmdsConvTab.add(new cmdsConvTab(27, false, false, false, false, false));    //
        standartCmdsConvTab.add(new cmdsConvTab(28, false, false, false, false, false));    //GO TO SCENE 12
        standartCmdsConvTab.add(new cmdsConvTab(29, false, false, false, false, false));    //
        standartCmdsConvTab.add(new cmdsConvTab(30, false, false, false, false, false));    //
        standartCmdsConvTab.add(new cmdsConvTab(31, false, false, false, false, false));    //GO TO SCENE 15
        standartCmdsConvTab.add(new cmdsConvTab(RESET_OPCODE, false, false, false, false, true));     //RESET
        standartCmdsConvTab.add(new cmdsConvTab(33, true, false, false, false, true));      //STORE ACTUAL LEVEL IN DTR0
        standartCmdsConvTab.add(new cmdsConvTab(SAVE_PERSISTENT_VARIABLES, false, false, false, false, true));     //SAVE PERSISTENT VARIABLES
        standartCmdsConvTab.add(new cmdsConvTab(35, true, false, false, false, true));      //SET OPERATING MODE (DTR0)
        standartCmdsConvTab.add(new cmdsConvTab(36, true, false, false, false, true));      //RESET MEMORY BANK (DTR0)
        standartCmdsConvTab.add(new cmdsConvTab(37, false, false, false, false, true));     //IDENTIFY DEVICE
        standartCmdsConvTab.add(new cmdsConvTab(42, true, false, false, false, true));     //SET MAX LEVEL (DTR0)
        standartCmdsConvTab.add(new cmdsConvTab(43, true, false, false, false, true));     //SET MIN LEVEL (DTR0)
        standartCmdsConvTab.add(new cmdsConvTab(44, true, false, false, false, true));    //SET SYSTEM FAILURE LEVEL (DTR0)
        standartCmdsConvTab.add(new cmdsConvTab(45, true, false, false, false, true));    //SET POWER ON LEVEL (DTR0)
        standartCmdsConvTab.add(new cmdsConvTab(SET_FADE_TIME_OPCODE, true, false, false, false, true));     //SET FADE TIME (DTR0)
        standartCmdsConvTab.add(new cmdsConvTab(SET_FADE_RATE_OPCODE, true, false, false, false, true));    //SET FADE RATE (DTR0)
        standartCmdsConvTab.add(new cmdsConvTab(SET_EXTENDED_FADE_TIME_OPCODE, true, false, false, false, true));     //SET EXTENDED FADE TIME (DTR0)
        standartCmdsConvTab.add(new cmdsConvTab(64, true, false, false, false, true));     //SET SCENE 0
        standartCmdsConvTab.add(new cmdsConvTab(65, true, false, false, false, true));     //
        standartCmdsConvTab.add(new cmdsConvTab(66, true, false, false, false, true));     //
        standartCmdsConvTab.add(new cmdsConvTab(67, true, false, false, false, true));     //SET SCENE 3
        standartCmdsConvTab.add(new cmdsConvTab(68, true, false, false, false, true));     //
        standartCmdsConvTab.add(new cmdsConvTab(69, true, false, false, false, true));     //
        standartCmdsConvTab.add(new cmdsConvTab(70, true, false, false, false, true));     //SET SCENE 6
        standartCmdsConvTab.add(new cmdsConvTab(71, true, false, false, false, true));    //
        standartCmdsConvTab.add(new cmdsConvTab(72, true, false, false, false, true));     //
        standartCmdsConvTab.add(new cmdsConvTab(73, true, false, false, false, true));     //SET SCENE 9
        standartCmdsConvTab.add(new cmdsConvTab(74, true, false, false, false, true));     //
        standartCmdsConvTab.add(new cmdsConvTab(75, true, false, false, false, true));     //
        standartCmdsConvTab.add(new cmdsConvTab(76, true, false, false, false, true));     //SET SCENE 12
        standartCmdsConvTab.add(new cmdsConvTab(77, true, false, false, false, true));
        standartCmdsConvTab.add(new cmdsConvTab(78, true, false, false, false, true));
        standartCmdsConvTab.add(new cmdsConvTab(79, true, false, false, false, true));     //SET SCENE 15
        standartCmdsConvTab.add(new cmdsConvTab(80, false, false, false, false, true));    //REMOVE FROM SCENE 0
        standartCmdsConvTab.add(new cmdsConvTab(81, false, false, false, false, true));   //
        standartCmdsConvTab.add(new cmdsConvTab(82, false, false, false, false, true));    //
        standartCmdsConvTab.add(new cmdsConvTab(83, false, false, false, false, true));    //REMOVE FROM SCENE 3
        standartCmdsConvTab.add(new cmdsConvTab(84, false, false, false, false, true));    //
        standartCmdsConvTab.add(new cmdsConvTab(85, false, false, false, false, true));    //
        standartCmdsConvTab.add(new cmdsConvTab(86, false, false, false, false, true));    //REMOVE FROM SCENE 6
        standartCmdsConvTab.add(new cmdsConvTab(87, false, false, false, false, true));    //
        standartCmdsConvTab.add(new cmdsConvTab(88, false, false, false, false, true));   //
        standartCmdsConvTab.add(new cmdsConvTab(89, false, false, false, false, true));    //REMOVE FROM SCENE 9
        standartCmdsConvTab.add(new cmdsConvTab(90, false, false, false, false, true));    //
        standartCmdsConvTab.add(new cmdsConvTab(91, false, false, false, false, true));    //
        standartCmdsConvTab.add(new cmdsConvTab(92, false, false, false, false, true));    //REMOVE FROM SCENE 12
        standartCmdsConvTab.add(new cmdsConvTab(93, false, false, false, false, true));    //
        standartCmdsConvTab.add(new cmdsConvTab(94, false, false, false, false, true));    //
        standartCmdsConvTab.add(new cmdsConvTab(95, false, false, false, false, true));   //REMOVE FROM SCENE 15
        standartCmdsConvTab.add(new cmdsConvTab(96, false, false, false, false, true));    //ADD TO GROUP 0
        standartCmdsConvTab.add(new cmdsConvTab(97, false, false, false, false, true));   //
        standartCmdsConvTab.add(new cmdsConvTab(98, false, false, false, false, true));    //
        standartCmdsConvTab.add(new cmdsConvTab(99, false, false, false, false, true));   //ADD TO GROUP 3
        standartCmdsConvTab.add(new cmdsConvTab(100, false, false, false, false, true));   //
        standartCmdsConvTab.add(new cmdsConvTab(101, false, false, false, false, true));   //
        standartCmdsConvTab.add(new cmdsConvTab(102, false, false, false, false, true));   //ADD TO GROUP 6
        standartCmdsConvTab.add(new cmdsConvTab(103, false, false, false, false, true));   //
        standartCmdsConvTab.add(new cmdsConvTab(104, false, false, false, false, true));   //
        standartCmdsConvTab.add(new cmdsConvTab(105, false, false, false, false, true));   //ADD TO GROUP 9
        standartCmdsConvTab.add(new cmdsConvTab(106, false, false, false, false, true));   //
        standartCmdsConvTab.add(new cmdsConvTab(107, false, false, false, false, true));//
        standartCmdsConvTab.add(new cmdsConvTab(108, false, false, false, false, true));   //ADD TO GROUP 12
        standartCmdsConvTab.add(new cmdsConvTab(109, false, false, false, false, true));   //
        standartCmdsConvTab.add(new cmdsConvTab(110, false, false, false, false, true));   //
        standartCmdsConvTab.add(new cmdsConvTab(111, false, false, false, false, true));   //ADD TO GROUP 15
        standartCmdsConvTab.add(new cmdsConvTab(112, false, false, false, false, true));   //REMOVE FROM GROUP 0
        standartCmdsConvTab.add(new cmdsConvTab(113, false, false, false, false, true));   //
        standartCmdsConvTab.add(new cmdsConvTab(114, false, false, false, false, true));  //
        standartCmdsConvTab.add(new cmdsConvTab(115, false, false, false, false, true));   //REMOVE FROM GROUP 3
        standartCmdsConvTab.add(new cmdsConvTab(116, false, false, false, false, true));   //
        standartCmdsConvTab.add(new cmdsConvTab(117, false, false, false, false, true));   //
        standartCmdsConvTab.add(new cmdsConvTab(118, false, false, false, false, true));   //REMOVE FROM GROUP 6
        standartCmdsConvTab.add(new cmdsConvTab(119, false, false, false, false, true));   //
        standartCmdsConvTab.add(new cmdsConvTab(120, false, false, false, false, true));   //
        standartCmdsConvTab.add(new cmdsConvTab(121, false, false, false, false, true));   //REMOVE FROM GROUP 9
        standartCmdsConvTab.add(new cmdsConvTab(122, false, false, false, false, true));   //
        standartCmdsConvTab.add(new cmdsConvTab(123, false, false, false, false, true));   //
        standartCmdsConvTab.add(new cmdsConvTab(124, false, false, false, false, true));   //REMOVE FROM GROUP 12
        standartCmdsConvTab.add(new cmdsConvTab(125, false, false, false, false, true));  //
        standartCmdsConvTab.add(new cmdsConvTab(126, false, false, false, false, true));   //
        standartCmdsConvTab.add(new cmdsConvTab(127, false, false, false, false, true)); //REMOVE FROM GROUP 15
        standartCmdsConvTab.add(new cmdsConvTab(128, true, false, false, false, true));    //SET SHORT ADDRESS (DTR0)
        standartCmdsConvTab.add(new cmdsConvTab(ENABLE_WRITE_MEMORY, false, false, false, false, true));   //ENABLE WRITE MEMORY
        standartCmdsConvTab.add(new cmdsConvTab(QUERY_STATUS, false, false, false, true, false));   //QUERY STATUS
        standartCmdsConvTab.add(new cmdsConvTab(145, false, false, false, true, false));   //QUERY CONTROL GEAR PRESENT
        standartCmdsConvTab.add(new cmdsConvTab(146, false, false, false, true, false));   //QUERY LAMP FAILURE
        standartCmdsConvTab.add(new cmdsConvTab(147, false, false, false, true, false));   //QUERY LAMP POWER ON
        standartCmdsConvTab.add(new cmdsConvTab(148, false, false, false, true, false));   //QUERY LIMIT ERROR
        standartCmdsConvTab.add(new cmdsConvTab(149, false, false, false, true, false));   //QUERY RESET STATE
        standartCmdsConvTab.add(new cmdsConvTab(150, false, false, false, true, false));   //QUERY MISSING SHORT ADDRESS
        standartCmdsConvTab.add(new cmdsConvTab(QUERY_VERSION_NUMBER, false, false, false, true, false));   //0x97  151
        standartCmdsConvTab.add(new cmdsConvTab(QUERY_CONTENT_DTR0, true, false, false, true, false));    //152 QUERY CONTENT DTR0
        standartCmdsConvTab.add(new cmdsConvTab(QUERY_DEVICE_TYPE, false, false, false, true, false));   //0x99   153
        standartCmdsConvTab.add(new cmdsConvTab(154, false, false, false, true, false));   //QUERY PHYSICAL MINIMUM
        standartCmdsConvTab.add(new cmdsConvTab(155, false, false, false, true, false));   //QUERY POWER FAILURE
        standartCmdsConvTab.add(new cmdsConvTab(156, false, true, false, true, false));    //QUERY CONTENT DTR1
        standartCmdsConvTab.add(new cmdsConvTab(157, false, false, true, true, false));    //QUERY CONTENT DTR2
        standartCmdsConvTab.add(new cmdsConvTab(158, false, false, false, true, false));   //QUERY OPERATING MODE
        standartCmdsConvTab.add(new cmdsConvTab(159, false, false, false, true, false));   //QUERY LIGHT SOURCE TYPE
        standartCmdsConvTab.add(new cmdsConvTab(QUERY_ACTUAL_LEVEL, false, false, false, true, false));  //QUERY ACTUAL LEVEL
        standartCmdsConvTab.add(new cmdsConvTab(161, false, false, false, true, false));   //QUERY MAX LEVEL
        standartCmdsConvTab.add(new cmdsConvTab(162, false, false, false, true, false));   //QUERY MIN LEVEL
        standartCmdsConvTab.add(new cmdsConvTab(QUERY_POWER_ON_LEVEL, false, false, false, true, false));   //QUERY POWER ON LEVEL
        standartCmdsConvTab.add(new cmdsConvTab(QUERY_SYSTEM_FAILURE_LEVEL, false, false, false, true, false));   //QUERY SYSTEM FAILURE LEVEL
        standartCmdsConvTab.add(new cmdsConvTab(QUERY_FADE_TIME_RATE, false, false, false, true, false));   //QUERY FADE TIME/FADE RATE
        standartCmdsConvTab.add(new cmdsConvTab(166, false, false, false, true, false));   //QUERY MANUFACTURER SPECIFIC MODE
        standartCmdsConvTab.add(new cmdsConvTab(167, false, false, false, true, false));   //QUERY NEXT DEVICE TYPE
        standartCmdsConvTab.add(new cmdsConvTab(168, false, false, false, true, false));   //QUERY EXTENDED FADE TIME
        standartCmdsConvTab.add(new cmdsConvTab(169, false, false, false, true, false));   //QUERY CONTROL GEAR FAILURE
        standartCmdsConvTab.add(new cmdsConvTab(QUERY_SCENE_LEVEL_0, false, false, false, true, false));   //QUERY SCENE LEVEL 0
        standartCmdsConvTab.add(new cmdsConvTab(177, false, false, false, true, false));   //QUERY SCENE LEVEL 1
        standartCmdsConvTab.add(new cmdsConvTab(178, false, false, false, true, false));   //QUERY SCENE LEVEL 2
        standartCmdsConvTab.add(new cmdsConvTab(179, false, false, false, true, false));   //QUERY SCENE LEVEL 3
        standartCmdsConvTab.add(new cmdsConvTab(180, false, false, false, true, false));   //QUERY SCENE LEVEL 4
        standartCmdsConvTab.add(new cmdsConvTab(181, false, false, false, true, false));   //QUERY SCENE LEVEL 5
        standartCmdsConvTab.add(new cmdsConvTab(182, false, false, false, true, false));  //QUERY SCENE LEVEL 6
        standartCmdsConvTab.add(new cmdsConvTab(183, false, false, false, true, false));   //QUERY SCENE LEVEL 7
        standartCmdsConvTab.add(new cmdsConvTab(184, false, false, false, true, false));   //QUERY SCENE LEVEL 8
        standartCmdsConvTab.add(new cmdsConvTab(185, false, false, false, true, false));   //QUERY SCENE LEVEL 9
        standartCmdsConvTab.add(new cmdsConvTab(186, false, false, false, true, false));   //QUERY SCENE LEVEL 10
        standartCmdsConvTab.add(new cmdsConvTab(187, false, false, false, true, false));   //QUERY SCENE LEVEL 11
        standartCmdsConvTab.add(new cmdsConvTab(188, false, false, false, true, false));  //QUERY SCENE LEVEL 12
        standartCmdsConvTab.add(new cmdsConvTab(189, false, false, false, true, false));   //QUERY SCENE LEVEL 13
        standartCmdsConvTab.add(new cmdsConvTab(190, false, false, false, true, false));   //QUERY SCENE LEVEL 14
        standartCmdsConvTab.add(new cmdsConvTab(QUERY_SCENE_LEVEL_15, false, false, false, true, false));   //QUERY SCENE LEVEL 15
        standartCmdsConvTab.add(new cmdsConvTab(192, false, false, false, true, false));   //QUERY GROUPS 0-7
        standartCmdsConvTab.add(new cmdsConvTab(193, false, false, false, true, false));   //QUERY GROUPS 8-15
        standartCmdsConvTab.add(new cmdsConvTab(QUERY_RANDOM_ADDR_H, false, false, false, true, false));   //QUERY RANDOM ADDRESS (H)
        standartCmdsConvTab.add(new cmdsConvTab(QUERY_RANDOM_ADDR_M, false, false, false, true, false));   //QUERY RANDOM ADDRESS (M)
        standartCmdsConvTab.add(new cmdsConvTab(QUERY_RANDOM_ADDR_L, false, false, false, true, false));   //QUERY RANDOM ADDRESS (L)
        standartCmdsConvTab.add(new cmdsConvTab(READ_MEMORY_LOCATION, true, true, false, true, false));     //READ MEMORY LOCATION (DTR1, DTR0)
        
        specCmdsConvTab.add(new specCmdsConvTab((byte)0XA1, 256, false, false, false));  //TERMINATE
        specCmdsConvTab.add(new specCmdsConvTab((byte)0XA3, 257, true, false, false));   //DTR0
        specCmdsConvTab.add(new specCmdsConvTab((byte)0xA5, 258, true, true, false));    //INITIALISE
        specCmdsConvTab.add(new specCmdsConvTab((byte)0xA7, 259, false, true, false));   //RANDOMISE
        specCmdsConvTab.add(new specCmdsConvTab((byte)0xA9, 260, false, false, true));   //COMPARE
        specCmdsConvTab.add(new specCmdsConvTab((byte)0xAB, 261, false, false, false));  //WITHDRAW
        specCmdsConvTab.add(new specCmdsConvTab((byte)0xAD, 262, false, false, false));  //PING
        specCmdsConvTab.add(new specCmdsConvTab((byte)0xB1, 264, true, false, false));   //SEARCHADDRH
        specCmdsConvTab.add(new specCmdsConvTab((byte)0xB3, 265, true, false, false));   //SEARCHADDRM
        specCmdsConvTab.add(new specCmdsConvTab((byte)0xB5, 266, true, false, false));   //SEARCHADDRL
        specCmdsConvTab.add(new specCmdsConvTab((byte)0xB7, 267, true, false, false));   //PROGRAM SHORT ADDRESS
        specCmdsConvTab.add(new specCmdsConvTab((byte)0xB9, 268, true, false, true));    //VERIFY SHORT ADDRESS
        specCmdsConvTab.add(new specCmdsConvTab((byte)0xBB, 269, false, false, true));   //QUERY SHORT ADDRESS
        specCmdsConvTab.add(new specCmdsConvTab((byte)ENABLE_DEVICE_TYPE_OPCODE, 272, true, false, false));   //ENABLE DEVICE TYPE
        specCmdsConvTab.add(new specCmdsConvTab((byte)SET_DTR1_OPCODE, 273, true, false, false));   //DTR1
        specCmdsConvTab.add(new specCmdsConvTab((byte)0xC5, 274, true, false, false));   //DTR2
        specCmdsConvTab.add(new specCmdsConvTab((byte)0xC7, 275, true, false, true));     //WRITE MEMORY LOCATION
        specCmdsConvTab.add(new specCmdsConvTab((byte)0xC9, 276, true, false, false));    //WRITE MEMORY LOCATION - NO REPLY
    }
    
  
    public byte getSpec(String text)
    {
        byte rval = 0;
        if(text == "207")
            rval = SPEC_LED_LAMP;
        else if(text == "202")
            rval = SPEC_SELF_CONTAINED_EMERGENCY_LIGHTNING;
        else if(text == "205")
            rval = SPEC_INCANDESCENT_LAMP;
        else if(text == "209")
            rval = SPEC_COLOUR_CONTROL;
        return rval;
    }
        
    public byte getStandartCmdAddrByte(byte cmd_type, byte destination, boolean is_dapc)
    {
        byte addr_byte = 0;
        if(cmd_type == BROADCAST_ADDR)
        {
            addr_byte = (byte)0xFF;
        }
        else if(cmd_type == BROADCAST_UNADDRESSED)
        {
            addr_byte = (byte)0xFD;
        }
        else if(cmd_type == GROUP_ADDR)
        {
            addr_byte = (byte)(destination<<1);
            addr_byte |= 0x81; //Bit 8 =’1’: standard command; bit 15 = 1
            addr_byte &= 0x9F; //Bits 14, 13 = 0
        }
        else if(cmd_type == INDIVIDUAL_ADDR)
        {
            addr_byte = (byte)(destination<<1);
            addr_byte |= 0x01; //Bit 8 =’1’: standard command;
            addr_byte &= 0x7F; //Bit 15 = 0
        }
        if(is_dapc)
            addr_byte &= 0xFE; //Bit 8 =’0’: direct arc power control (DAPC) command;
        return addr_byte;
    }        
     
    boolean checkCmdIssueTwice(int cmdId, byte specification)
    {
        boolean rval = false;
        if(cmdId > 0xFF) //Special commands
        {
            for(byte i = 0; i < specCmdsConvTab.size(); i++)
            {
                if(specCmdsConvTab.get(i).cmdNum  == cmdId)
                {
                    rval =  specCmdsConvTab.get(i).sendTwice;
                    break;
                }
            }
        }
        else  //Standart commands
        {
            boolean found = false;
            for(byte i = 0; i < standartCmdsConvTab.size(); i++)
            {
                byte comNmb = standartCmdsConvTab.get(i).cmdNum;
                if(comNmb  == (byte)cmdId)
                {
                    rval =  standartCmdsConvTab.get(i).sendTwice;
                    found = true;
                    break;
                }
            }
            if(!found)
            {
                if(specification == SPEC_LED_LAMP)
                {
                    for(byte i = 0; i < extendedCmdsSpec207ConvTab.size(); i++)
                    {
                        byte comNmb = (byte)extendedCmdsSpec207ConvTab.get(i).cmdNum;
                        if(comNmb == (byte)cmdId)
                        {
                            rval =  extendedCmdsSpec207ConvTab.get(i).sendTwice;
                            found = true;
                            break;
                        }
                    }
                }
                else if(specification == SPEC_INCANDESCENT_LAMP)
                {
                    for(byte i = 0; i < extendedCmdsSpec205ConvTab.size(); i++)
                    {
                        byte comNmb = (byte)extendedCmdsSpec205ConvTab.get(i).cmdNum;
                        if(comNmb  == (byte)cmdId)
                        {
                            rval =  extendedCmdsSpec205ConvTab.get(i).sendTwice;
                            found = true;
                            break;
                        }
                    }
                }
                else if(specification == SPEC_COLOUR_CONTROL)
                {
                    for(byte i = 0; i < extendedCmdsSpec209ConvTab.size(); i++)
                    {
                        byte comNmb = (byte)extendedCmdsSpec209ConvTab.get(i).cmdNum;
                        if(comNmb  == (byte)cmdId)
                        {
                            rval =  extendedCmdsSpec209ConvTab.get(i).sendTwice;
                            found = true;
                            break;
                        }
                    }
                }
            }
        }
        return rval;
    }
    
    boolean checkCmdNeedAnswer(int cmdId, byte specification)
    {
        boolean rval = false;
        if(cmdId > 0xFF) //Special commands
        {
            for(int i = 0; i < specCmdsConvTab.size(); i++)
            {
                byte comNmb = (byte)specCmdsConvTab.get(i).cmdNum;
                if(comNmb  == (byte)cmdId)
                {
                    rval =  specCmdsConvTab.get(i).answer;
                }
            }
        }
        else  //Standart commands
        {
            boolean found = false;
            for(byte i = 0; i < standartCmdsConvTab.size(); i++)
            {
                byte comNmb = (byte)standartCmdsConvTab.get(i).cmdNum;
                if(comNmb  == (byte)cmdId)
                {
                    rval =  standartCmdsConvTab.get(i).answer;
                    found = true;
                    break;
                }
            }
            if(!found)
            {
                if(specification == SPEC_LED_LAMP)
                {
                    for(byte i = 0; i < extendedCmdsSpec207ConvTab.size(); i++)
                    {
                        byte comNmb = (byte)extendedCmdsSpec207ConvTab.get(i).cmdNum;
                        if(comNmb  == (byte)cmdId)
                        {
                            rval =  extendedCmdsSpec207ConvTab.get(i).answer;
                          //  found = true;
                            break;
                        }
                    }
                }
                else if(specification == SPEC_INCANDESCENT_LAMP)
                {
                    for(byte i = 0; i < extendedCmdsSpec205ConvTab.size(); i++)
                    {
                        byte comNmb = (byte)extendedCmdsSpec205ConvTab.get(i).cmdNum;
                        if(comNmb  == (byte)cmdId)
                        {
                            rval =  extendedCmdsSpec205ConvTab.get(i).answer;
                          //  found = true;
                            break;
                        }
                    }
                }
                else if(specification == SPEC_COLOUR_CONTROL)
                {
                    for(byte i = 0; i < extendedCmdsSpec209ConvTab.size(); i++)
                    {
                        byte comNmb = (byte)extendedCmdsSpec209ConvTab.get(i).cmdNum;
                        if(comNmb  == (byte)cmdId)
                        {
                            rval =  extendedCmdsSpec209ConvTab.get(i).answer;
                          //  found = true;
                            break;
                        }
                    }
                }
            }
        }
        return rval;
    }

    boolean checkCmdSpecial(int cmdId)
    {
        boolean rval = false;
        if(cmdId > 0xFF) //Special commands
        {
           rval = true;
        }
        return rval;
    }

    byte getSpecialCmdAddrByteFromNumber(int number)
    {
        byte rval = 0;
        
        for(byte i = 0; i < specCmdsConvTab.size(); i++)
        {
            if(specCmdsConvTab.get(i).cmdNum == number)
            {
                rval = specCmdsConvTab.get(i).addressByte;
                break;
            }
        }
        return rval;
    }
   
    byte getSpecialCmdOpcodeByte(int cmdId, byte data)
    {
        byte opcode = 0;

        if(cmdId == 272) //ROUTH HARDCODING - NO NEED to setup data
        {
            data = 6;
        }

        for(byte i = 0; i < specCmdsConvTab.size(); i++)
        {
            if(specCmdsConvTab.get(i).cmdNum  == cmdId)
            {
                if(specCmdsConvTab.get(i).opcodeNotNull)
                {
                    opcode = data;
                    break;
                }
            }
        }
        return opcode;
    }
    
    byte calcCrc(byte[] data, int len)
    {
        int crc = 0;
        for(byte i = 0; i < len; i++)
        {
            crc += data[i];
        }
        crc = ~crc;
        return (byte)crc;
    }
    
    void buildCmd(byte data, String cmdStr, byte addrType, byte groupDest, byte addrDest, byte specification,  byte[] result)
    {
     
        int delimIx = cmdStr.indexOf(' ');
        int strLen =  cmdStr.length() ;
        String cmdNumStr;
        if(strLen > 0)
        {    
            cmdNumStr = cmdStr.substring(0, delimIx);
        } 
        else 
            return;
   
        boolean dapcFlag = false;
        if(cmdNumStr.equals("-")) //DAPC
        {
            dapcFlag = true;
            cmdId = 0;
        }
        else
        {
            cmdId = Integer.parseInt(cmdNumStr);
        }

        if((cmdId <= (int)0xFF) || dapcFlag)  //standart commands
        {
            byte destination = 0;
            if(addrType == GROUP_ADDR)
            {
                destination = groupDest;
            }
            else if(addrType == INDIVIDUAL_ADDR)
            {
                destination = addrDest;
            }
            address_byte = getStandartCmdAddrByte(addrType, destination, dapcFlag);
            if(dapcFlag)
            {
                opcode_byte = data;
            }
            else
            {
                opcode_byte = (byte)cmdId;
            }
        }
        else        //special commands
        {
            address_byte = getSpecialCmdAddrByteFromNumber(cmdId);
            opcode_byte = getSpecialCmdOpcodeByte(cmdId, data);
        }
        
        boolean set_twice = checkCmdIssueTwice(cmdId, specification);
        boolean answer = checkCmdNeedAnswer(cmdId, specification);
        boolean is_special = checkCmdSpecial(cmdId);
        byte cmd_id = (byte)SLAVE_CMD;
        if(set_twice)
            cmd_id |= COMMAND_SEND_TWICE_FLAG;
        if(answer)
            cmd_id |= COMMAND_EXPECT_ANSWER_FLAG;
        if(is_special)
            cmd_id |= COMMAND_SPECIAL_FLAG;
        result[0] = cmd_id;
        result[1] = (byte)0x03;
        result[2] = address_byte;
        result[3] = opcode_byte;
        byte crc = calcCrc(result, 4);
        result[4] = crc;
    }
    
    public byte getAddress()
    {
        return address_byte;
    }
    
    public byte getOpcode()
    {
        return opcode_byte;
    }
     
    public byte getReply()
    {
        return replyByte;
    }
    
    private void replyFromMaster(byte[] data)
    {
        byte len = data[1];
        byte sub_reply_id = data[2];
        switch(sub_reply_id)
        {
            case MASTER_VID_PID:
            {
                if(len != 6)
                {
                    System.out.println("ERROR master vid pid len");
                }
                vid = data[3];
                vid += ((int)data[4]) * 256;

                pid = data[5];
                pid += ((int)data[6]) * 256;
            }
                break;
            default:

                break;
        }
    }
   
    public boolean parse(byte[] rxBuffer)
    {
        byte rd_crc = rxBuffer[rxBuffer.length - 1];
        byte crc = calcCrc(rxBuffer, rxBuffer.length - 1);
        if(crc != rd_crc)
        {
            System.out.println("ERROR crc calc");
            return false;
        }
        byte replyId = rxBuffer[0];
        switch(replyId)
        {
            case MASTER_CMD:
                replyFromMaster(rxBuffer);
                break;
            case SLAVE_CMD:
                replyByte = rxBuffer[2];
                break;  
        } 
        return true;
    }        
}
